<?

	function gfile_send_file($email, $from, $file)
	{
		$mime_boundary = "gmail" . md5(uniqid(mt_rand(), 1));
	
		$header  = "From: ".$from."\nMIME-Version: 1.0\nContent-Type: multipart/mixed;\n boundary=\"".$mime_boundary."\"\n";
		
		$content  = "--".$mime_boundary."\n";
		$content .= "Content-Type: text/plain; charset=\"iso-8859-1\"\n";
		$content .= "Content-Transfer-Encoding: 7bit\n\n";
		$content .= "File backup: ".basename($file)."\n";
		$content .= "--".$mime_boundary."\n";
		$content .= "Content-Disposition: attachment;\n";
		$content .= "Content-Type: Application/Octet-Stream;";
		$content .= " name=\"".basename($file)."\"\n";
		$content .= "Content-Transfer-Encoding: base64\n\n";
		$content .= chunk_split(base64_encode(file_get_contents($file)))."\n";
		$content .= "--".$mime_boundary."\n";
		
		mail($email, "GFile " . basename($file), $content, $header);
	}
	
	function gfile_fetch_file ($a, $f, $n)
	{
		global $gm, $tempdir;
	
		if ($fn = gfile_download_to_local($a, $f, $n))
		{
			$f = @fopen($fn, 'rb');
			$ret = @fread($f, @filesize($fn));
			@fclose($f);
			SendDownloadHeaders($n, strlen($ret));
			echo $ret;
			@unlink($fn);
		}
		else
		{
			print "Could not download attachment";
			$gm->disconnect();
			exit;
		}
	}
	
	function gfile_display_image($a, $f, $n, $height, $width)
	{
		global $gm, $tempdir;
	
		if ($fn = gfile_download_to_local($a, $f, $n))
		{
			header("Content-type: image/jpeg");

			list(,,$type) = getimagesize($fn);

			if ($type == 1)
				$image = imagecreatefromgif($fn);
			if ($type == 2)
				$image = imagecreatefromjpeg($fn);
			if ($type == 3)
				$image = imagecreatefrompng($fn);
			
			if (($height == "") && ($width == ""))
			{
				$width = imagesx($image);
				$height = imagesy($image);
			}
			
			if (($height == "") && ($width != ""))
				$height = ($width/imagesx($image)) * imagesy($image);
		
			if (($height != "") && ($width == ""))
				$width = ($height/imagesy($image)) * imagesx($image);
		
			$resImage = imagecreatetruecolor($width, $height);
			imagecopyresized($resImage, $image, 0, 0, 0, 0, $width, $height, imagesx($image), imagesy($image));
			
			imagejpeg($resImage);
			imagedestroy($image);
			imagedestroy($resImage);
			
			unlink($fn);
		}
		else
		{
			print "Could not display image";
			$gm->disconnect();
			exit;
		}
				
	}
	
	function gfile_rename($a, $f, $n, $nn)
	{
		global $gm, $tempdir;
		
		if ($fn = gfile_download_to_local($a, $f, $n))
		{
			rename($fn, $tempdir . $nn);
			return $tempdir . $nn;
		}

		unlink($fn);
		return false;

	}
	
	function gfile_download_to_local($a, $f, $n)
	{	
		global $gm, $tempdir;

		$fn = $tempdir . $n;

		if (!$gm->isConnected())
		{
			if (!$gm->connect())
			{
				print "Error connecting...."; exit;
			}
		}
		
		$_SESSION['gm'] = $gm;
	
		if ($gm->getAttachment($a, $f, $fn))
			return $fn;

		unlink($fn);
		return false;

	}

	function SendDownloadHeaders($filename, $filesize=0)
	{
		$HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];
		$isIE = $isIE6 = 0;
	
		if (strstr($HTTP_USER_AGENT, 'compatible; MSIE ') !== false && strstr($HTTP_USER_AGENT, 'Opera') === false)
		{
			$isIE = 1;
		}
	
		if (strstr($HTTP_USER_AGENT, 'compatible; MSIE 6') !== false && strstr($HTTP_USER_AGENT, 'Opera') === false)
		{
			$isIE6 = 1;
		}
	
		// A Pox on Microsoft and it's Internet Explorer!
		//
		// IE has lots of bugs with file downloads.
		// It also has problems with SSL.  Both of these cause problems
		// for us in this function.
		//
		// See this article on Cache Control headers and SSL
		// http://support.microsoft	.com/default.aspx?scid=kb;en-us;323308
		//
		// The best thing you can do for IE is to upgrade to the latest
		// version
		//set all the Cache Control Headers for IE
		
		if ($isIE)
		{
			header ("Pragma: public");
			header ("Cache-Control: no-store, max-age=0, no-cache, must-revalidate"); # HTTP/1.1
			header ("Cache-Control: post-check=0, pre-check=0", false);
			header ("Cache-control: private");
			//set the inline header for IE, we'll add the attachment header later if we need it
			header ("Content-Disposition: inline; filename=$filename");
		}
		
		// Try to pop up the "save as" box
		// IE makes this hard.  It pops up 2 save boxes, or none.
		// http://support.microsoft.com/support/kb/articles/Q238/5/88.ASP
		// http://support.microsoft.com/default.aspx?scid=kb;EN-US;260519
		// But, according to Microsoft, it is "RFC compliant but doesn't
		// take into account some deviations that allowed within the
		// specification."  Doesn't that mean RFC non-compliant?
		// http://support.microsoft.com/support/kb/articles/Q258/4/52.ASP
		// all browsers need the application/octet-stream header for this
		
		header ("Content-Type: application/octet-stream; name=\"$filename\"");
		
		// http://support.microsoft.com/support/kb/articles/Q182/3/15.asp
		// Do not have quotes around filename, but that applied to
		// "attachment"... does it apply to inline too?
		
		header ("Content-Disposition: attachment; filename=\"$filename\"");
		
		if ($isIE && !$isIE6)
		{
			// This combination seems to work mostly.  IE 5.5 SP 1 has
			// known issues (see the Microsoft Knowledge Base)
			// This works for most types, but doesn't work with Word files
			
			header ("Content-Type: application/download; name=\"$filename\"");
		}
		else
		{
			// another application/octet-stream forces download for Netscape
			header ("Content-Type: application/octet-stream; name=\"$filename\"");
		}

		//send the content-length header if the calling function provides it
		if ($filesize > 0)
			header("Content-Length: $filesize");
			
	}  // end fn SendDownloadHeaders
	

?>